package com.simplepart.samples.textformatting;

import com.simplepart.offbeat.HitResolution;
import org.springframework.ui.velocity.VelocityEngineUtils;
import org.apache.velocity.app.VelocityEngine;

import java.util.Map;
import java.util.HashMap;


public class VelocityFormatter implements DamageFormatter {

    private VelocityEngine velocityEngine;
    private String templatePath;

    public VelocityFormatter(VelocityEngine velocityEngine, String templatePath) {
        this.velocityEngine = velocityEngine;
        this.templatePath = templatePath;
    }

    public String format(HitResolution resolution) {

        Map model = new HashMap();
        model.put("attacker", resolution.getAttacker());
        model.put("target", resolution.getTarget());
        model.put("damage", resolution.getDamage());

        return VelocityEngineUtils.mergeTemplateIntoString(velocityEngine, templatePath, model);
    }
}
